<template>
  <div class="relative">
    <button class="" @click="toggleDropdown()">
      {{ selectedMarket.name }}<span class="caret ml-1" />
    </button>
    <ul v-if="isDropdownVisible" class="w-44 text-right absolute right-0 top-5 bg-white p-4 shadow-xl z-50">
      <li v-for="(market, index) in availableMarkets" :key="market.id" :class="{ 'mb-1': index < availableMarkets.length -1 }">
        <button @click="select(market)">
          {{ market.name }}
        </button>
      </li>
    </ul>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { mapState } from 'vuex';

export default Vue.extend({
  props: {
    activeMarketId: {
      type: String,
      default: ''
    }
  },

  data () {
    return {
      isDropdownVisible: false,
      selectedMarket: null as any
    };
  },

  computed: {
    ...mapState({
      availableMarkets: (state: any) => state.marketData.map((data: any) => ({ id: data.marketId, name: data.indexName }))
    })
  },

  created () {
    if (this.activeMarketId) {
      this.select(this.availableMarkets.find((market: any) => market.id === this.activeMarketId));
    } else {
      this.select(this.availableMarkets[0]);
    }
  },

  methods: {
    select (market: any) {
      this.selectedMarket = market;
      this.isDropdownVisible = false;

      this.$emit('market-select', market.id);
    },

    toggleDropdown (): void {
      this.isDropdownVisible = !this.isDropdownVisible;
    }
  }
});
</script>

<style lang="scss" scoped>
.caret {
  display: inline-block;
  border-left: 6px solid transparent;
  border-right: 6px solid transparent;
  border-top: 8px solid rgb(78, 78, 78);
  width: 1px;
  vertical-align: middle;
}
</style>
